### Some functions shared by LPR_ngram_seg and LPR_vocab_decomp
###

from multi_helper import *

def in_span(span,point):
    return span[1] > point >= span[0]

def in_skip_span(span,point):
    return span[2] > point >= span[0] or  span[1] > point >= span[3]

def overlaps(span1,span2):
    return not (span1[1] <= span2[0] or span1[0] >= span2[1])

def get_len(span):
    return span[0] - span[1]

def compatible_with_breaks(span,breaks):
    for i in range(span[0]+1,span[1]):
        if i in breaks:
            return False
    return True

def get_ranking_of_predictors(words,index,spans,cond_prob_dict,skip_spans,skip_cond_prob_dict):
    '''
    this function uses existing LPR statistics to rank the best spans for LPR
    among the contexts given in spans and skip_spans
    '''
    
    relevant_spans = []
    for span in spans:
        if in_span(span,index):
           relevant_spans.append(span)
    results = {}
    for span in relevant_spans:
        for i in range(index + 1, span[1] + 1):
            for j in range(index,span[0] - 1,-1):
                if i - j == 1:
                    continue
                rep = (j,i)
                if rep in results:
                    continue
                results[rep] = cond_prob_dict[get_multi_id_range(words,j,i)][index-j]

    relevant_skip_spans = []
    for span in skip_spans:
        if in_skip_span(span,index):
            relevant_skip_spans.append(span)

    #print relevant_skip_spans

    for span in relevant_skip_spans:
        if span[0] <= index < span[2]:
            for i in range(span[3] + 1, span[1] + 1):
                for j in range(index,span[0] - 1,-1):
                    rep = (j, i, span[2],span[3])
                    try:
                        results[rep] = skip_cond_prob_dict[get_multi_id_range_skip(words,j,span[2],span[3],i)][index-j]
                    except:
                        pass

        else:
            for i in range(index + 1, span[1] + 1):
                for j in range(span[2] -1, span[0] -1,-1):
                    rep = (j, i, span[2],span[3])
                    try:
                        results[rep] = skip_cond_prob_dict[get_multi_id_range_skip(words,j,span[2],span[3],i)][index-j - (span[3] - span[2])]
                    except:
                        pass
                
    results[(index,index+1)] = 0
    to_sort = zip(results.values(), map(get_len,results.keys()), results.keys())
    to_sort.sort()
    return to_sort
